/***************************************************
* C source with CCS
* File Name: 20120420_talkingdice.c
* Description: check start sw, replay sw, generate random number and play
* PIN A0 for start, active low
* PIN A1 for replay, active low
* PIN A2 for led, active high
* PIN A3 for busy, active low
* PIN A4 for rxd
* PIN A5 for reset, active low
* COPYRIGHT 2012 MYCOMKITS.COM, owned by CNET LIMITED
* vO̒쌠́Aҁu}C* RLbghbgR^c@LЃNlbgvɋA܂B
* 쌠Ă܂񂪁AvOgwK̒ŃvORɕύXĂgB
***************************************************/
// include headre file
#define RAND_MAX 6 // generate random number 0 to 5
#include <12f675.h>
#include <stdlib.h>

// settings
#fuses INTRC_IO, NOWDT, NOPUT, NOPROTECT, NOMCLR, NOBROWNOUT, NOCPD
#use delay(CLOCK = 4000000)
#use rs232(BAUD = 9600, XMIT = PIN_A4)
//
//
int seed = 0;
int firstflag = 1;
int number = 1;
int i;

//
// main
//
void main()
{
	//

	SET_TRIS_A(0x0B); //A5,4,2 output, A3,1,0 input
	setup_adc_ports(NO_ANALOGS); // all degital
	//initialize
	seed = 0;
	firstflag = 1;
	number = 1;
	output_low(PIN_A2); // turn off LED
	PORT_A_PULLUPS(TRUE);
	// reset ATP3011
	output_high(PIN_A5);
	output_low(PIN_A5);
	delay_ms(500);
	output_high(PIN_A5);
	delay_ms(100);
	//
	printf("?"); //set baud rate
	delay_ms(100);
	//
	printf("de'nshisaikoro/kido'ushima'shita");
	putc(0x0D);
	//
	// main loop
	while(1)
	{
		seed = seed + 1;
		// start
		if(input(PIN_A0)==0)
		{
			delay_ms(50); //check it again for chattaling
			if(input(PIN_A0)==0)
			{
				if(firstflag == 1)
				{
					srand(seed); //seed for random number
					firstflag = 0;
				}
				number = rand() + 1;
				//
				for(i=0; i<number; i++)
				{
					delay_ms(500);
				}
				//
				number = rand() + 1;
				//
				while(input(PIN_A3)==0) {} //busy
				//
				output_high(PIN_A2); // turn on LED
				//
				putc(0x3C);
				printf("NUMK VAL=");
				printf("%u",number);
				putc(0x3E);
				putc(0x0D);
				//
				output_low(PIN_A2); // turn off LED
				//
				while(input(PIN_A0)==0) {} // hold during pressing A0
				//
			}
		}
		// replay
		else if(input(PIN_A1)==0)
		{
			delay_ms(50); //check it again for chattaling
			if(input(PIN_A1)==0)
			{

				while(input(PIN_A3)==0) {} //busy
				//
				output_high(PIN_A2); // turn on LED
				//
				putc(0x3C);
				printf("NUMK VAL=");
				printf("%u",number);
				putc(0x3E);
				putc(0x0D);
				//
				output_low(PIN_A2); // turn off LED
				//
				while(input(PIN_A1)==0);
			}
		}
	}
}
